// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ds_dbw_msgs:msg/DriverAssist.idl
// generated code does not contain a copyright notice
#include "ds_dbw_msgs/msg/detail/driver_assist__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `decel_src`
#include "ds_dbw_msgs/msg/detail/decel_src__functions.h"

bool
ds_dbw_msgs__msg__DriverAssist__init(ds_dbw_msgs__msg__DriverAssist * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    ds_dbw_msgs__msg__DriverAssist__fini(msg);
    return false;
  }
  // decel
  // decel_src
  if (!ds_dbw_msgs__msg__DecelSrc__init(&msg->decel_src)) {
    ds_dbw_msgs__msg__DriverAssist__fini(msg);
    return false;
  }
  // fcw_active
  // fcw_enabled
  // aeb_active
  // aeb_precharge
  // aeb_enabled
  // acc_braking
  // acc_enabled
  // blis_l_alert
  // blis_l_enabled
  // blis_r_alert
  // blis_r_enabled
  // cta_l_alert
  // cta_l_enabled
  // cta_r_alert
  // cta_r_enabled
  return true;
}

void
ds_dbw_msgs__msg__DriverAssist__fini(ds_dbw_msgs__msg__DriverAssist * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // decel
  // decel_src
  ds_dbw_msgs__msg__DecelSrc__fini(&msg->decel_src);
  // fcw_active
  // fcw_enabled
  // aeb_active
  // aeb_precharge
  // aeb_enabled
  // acc_braking
  // acc_enabled
  // blis_l_alert
  // blis_l_enabled
  // blis_r_alert
  // blis_r_enabled
  // cta_l_alert
  // cta_l_enabled
  // cta_r_alert
  // cta_r_enabled
}

bool
ds_dbw_msgs__msg__DriverAssist__are_equal(const ds_dbw_msgs__msg__DriverAssist * lhs, const ds_dbw_msgs__msg__DriverAssist * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // decel
  if (lhs->decel != rhs->decel) {
    return false;
  }
  // decel_src
  if (!ds_dbw_msgs__msg__DecelSrc__are_equal(
      &(lhs->decel_src), &(rhs->decel_src)))
  {
    return false;
  }
  // fcw_active
  if (lhs->fcw_active != rhs->fcw_active) {
    return false;
  }
  // fcw_enabled
  if (lhs->fcw_enabled != rhs->fcw_enabled) {
    return false;
  }
  // aeb_active
  if (lhs->aeb_active != rhs->aeb_active) {
    return false;
  }
  // aeb_precharge
  if (lhs->aeb_precharge != rhs->aeb_precharge) {
    return false;
  }
  // aeb_enabled
  if (lhs->aeb_enabled != rhs->aeb_enabled) {
    return false;
  }
  // acc_braking
  if (lhs->acc_braking != rhs->acc_braking) {
    return false;
  }
  // acc_enabled
  if (lhs->acc_enabled != rhs->acc_enabled) {
    return false;
  }
  // blis_l_alert
  if (lhs->blis_l_alert != rhs->blis_l_alert) {
    return false;
  }
  // blis_l_enabled
  if (lhs->blis_l_enabled != rhs->blis_l_enabled) {
    return false;
  }
  // blis_r_alert
  if (lhs->blis_r_alert != rhs->blis_r_alert) {
    return false;
  }
  // blis_r_enabled
  if (lhs->blis_r_enabled != rhs->blis_r_enabled) {
    return false;
  }
  // cta_l_alert
  if (lhs->cta_l_alert != rhs->cta_l_alert) {
    return false;
  }
  // cta_l_enabled
  if (lhs->cta_l_enabled != rhs->cta_l_enabled) {
    return false;
  }
  // cta_r_alert
  if (lhs->cta_r_alert != rhs->cta_r_alert) {
    return false;
  }
  // cta_r_enabled
  if (lhs->cta_r_enabled != rhs->cta_r_enabled) {
    return false;
  }
  return true;
}

bool
ds_dbw_msgs__msg__DriverAssist__copy(
  const ds_dbw_msgs__msg__DriverAssist * input,
  ds_dbw_msgs__msg__DriverAssist * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // decel
  output->decel = input->decel;
  // decel_src
  if (!ds_dbw_msgs__msg__DecelSrc__copy(
      &(input->decel_src), &(output->decel_src)))
  {
    return false;
  }
  // fcw_active
  output->fcw_active = input->fcw_active;
  // fcw_enabled
  output->fcw_enabled = input->fcw_enabled;
  // aeb_active
  output->aeb_active = input->aeb_active;
  // aeb_precharge
  output->aeb_precharge = input->aeb_precharge;
  // aeb_enabled
  output->aeb_enabled = input->aeb_enabled;
  // acc_braking
  output->acc_braking = input->acc_braking;
  // acc_enabled
  output->acc_enabled = input->acc_enabled;
  // blis_l_alert
  output->blis_l_alert = input->blis_l_alert;
  // blis_l_enabled
  output->blis_l_enabled = input->blis_l_enabled;
  // blis_r_alert
  output->blis_r_alert = input->blis_r_alert;
  // blis_r_enabled
  output->blis_r_enabled = input->blis_r_enabled;
  // cta_l_alert
  output->cta_l_alert = input->cta_l_alert;
  // cta_l_enabled
  output->cta_l_enabled = input->cta_l_enabled;
  // cta_r_alert
  output->cta_r_alert = input->cta_r_alert;
  // cta_r_enabled
  output->cta_r_enabled = input->cta_r_enabled;
  return true;
}

ds_dbw_msgs__msg__DriverAssist *
ds_dbw_msgs__msg__DriverAssist__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__DriverAssist * msg = (ds_dbw_msgs__msg__DriverAssist *)allocator.allocate(sizeof(ds_dbw_msgs__msg__DriverAssist), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ds_dbw_msgs__msg__DriverAssist));
  bool success = ds_dbw_msgs__msg__DriverAssist__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
ds_dbw_msgs__msg__DriverAssist__destroy(ds_dbw_msgs__msg__DriverAssist * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    ds_dbw_msgs__msg__DriverAssist__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
ds_dbw_msgs__msg__DriverAssist__Sequence__init(ds_dbw_msgs__msg__DriverAssist__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__DriverAssist * data = NULL;

  if (size) {
    data = (ds_dbw_msgs__msg__DriverAssist *)allocator.zero_allocate(size, sizeof(ds_dbw_msgs__msg__DriverAssist), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ds_dbw_msgs__msg__DriverAssist__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ds_dbw_msgs__msg__DriverAssist__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ds_dbw_msgs__msg__DriverAssist__Sequence__fini(ds_dbw_msgs__msg__DriverAssist__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ds_dbw_msgs__msg__DriverAssist__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ds_dbw_msgs__msg__DriverAssist__Sequence *
ds_dbw_msgs__msg__DriverAssist__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  ds_dbw_msgs__msg__DriverAssist__Sequence * array = (ds_dbw_msgs__msg__DriverAssist__Sequence *)allocator.allocate(sizeof(ds_dbw_msgs__msg__DriverAssist__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = ds_dbw_msgs__msg__DriverAssist__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
ds_dbw_msgs__msg__DriverAssist__Sequence__destroy(ds_dbw_msgs__msg__DriverAssist__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    ds_dbw_msgs__msg__DriverAssist__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
ds_dbw_msgs__msg__DriverAssist__Sequence__are_equal(const ds_dbw_msgs__msg__DriverAssist__Sequence * lhs, const ds_dbw_msgs__msg__DriverAssist__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ds_dbw_msgs__msg__DriverAssist__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ds_dbw_msgs__msg__DriverAssist__Sequence__copy(
  const ds_dbw_msgs__msg__DriverAssist__Sequence * input,
  ds_dbw_msgs__msg__DriverAssist__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ds_dbw_msgs__msg__DriverAssist);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    ds_dbw_msgs__msg__DriverAssist * data =
      (ds_dbw_msgs__msg__DriverAssist *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ds_dbw_msgs__msg__DriverAssist__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          ds_dbw_msgs__msg__DriverAssist__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ds_dbw_msgs__msg__DriverAssist__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
