// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/DriverAssist.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'decel_src'
#include "ds_dbw_msgs/msg/detail/decel_src__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__DriverAssist __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__DriverAssist __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DriverAssist_
{
  using Type = DriverAssist_<ContainerAllocator>;

  explicit DriverAssist_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    decel_src(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->decel = 0.0f;
      this->fcw_active = false;
      this->fcw_enabled = false;
      this->aeb_active = false;
      this->aeb_precharge = false;
      this->aeb_enabled = false;
      this->acc_braking = false;
      this->acc_enabled = false;
      this->blis_l_alert = false;
      this->blis_l_enabled = false;
      this->blis_r_alert = false;
      this->blis_r_enabled = false;
      this->cta_l_alert = false;
      this->cta_l_enabled = false;
      this->cta_r_alert = false;
      this->cta_r_enabled = false;
    }
  }

  explicit DriverAssist_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    decel_src(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->decel = 0.0f;
      this->fcw_active = false;
      this->fcw_enabled = false;
      this->aeb_active = false;
      this->aeb_precharge = false;
      this->aeb_enabled = false;
      this->acc_braking = false;
      this->acc_enabled = false;
      this->blis_l_alert = false;
      this->blis_l_enabled = false;
      this->blis_r_alert = false;
      this->blis_r_enabled = false;
      this->cta_l_alert = false;
      this->cta_l_enabled = false;
      this->cta_r_alert = false;
      this->cta_r_enabled = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _decel_type =
    float;
  _decel_type decel;
  using _decel_src_type =
    ds_dbw_msgs::msg::DecelSrc_<ContainerAllocator>;
  _decel_src_type decel_src;
  using _fcw_active_type =
    bool;
  _fcw_active_type fcw_active;
  using _fcw_enabled_type =
    bool;
  _fcw_enabled_type fcw_enabled;
  using _aeb_active_type =
    bool;
  _aeb_active_type aeb_active;
  using _aeb_precharge_type =
    bool;
  _aeb_precharge_type aeb_precharge;
  using _aeb_enabled_type =
    bool;
  _aeb_enabled_type aeb_enabled;
  using _acc_braking_type =
    bool;
  _acc_braking_type acc_braking;
  using _acc_enabled_type =
    bool;
  _acc_enabled_type acc_enabled;
  using _blis_l_alert_type =
    bool;
  _blis_l_alert_type blis_l_alert;
  using _blis_l_enabled_type =
    bool;
  _blis_l_enabled_type blis_l_enabled;
  using _blis_r_alert_type =
    bool;
  _blis_r_alert_type blis_r_alert;
  using _blis_r_enabled_type =
    bool;
  _blis_r_enabled_type blis_r_enabled;
  using _cta_l_alert_type =
    bool;
  _cta_l_alert_type cta_l_alert;
  using _cta_l_enabled_type =
    bool;
  _cta_l_enabled_type cta_l_enabled;
  using _cta_r_alert_type =
    bool;
  _cta_r_alert_type cta_r_alert;
  using _cta_r_enabled_type =
    bool;
  _cta_r_enabled_type cta_r_enabled;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__decel(
    const float & _arg)
  {
    this->decel = _arg;
    return *this;
  }
  Type & set__decel_src(
    const ds_dbw_msgs::msg::DecelSrc_<ContainerAllocator> & _arg)
  {
    this->decel_src = _arg;
    return *this;
  }
  Type & set__fcw_active(
    const bool & _arg)
  {
    this->fcw_active = _arg;
    return *this;
  }
  Type & set__fcw_enabled(
    const bool & _arg)
  {
    this->fcw_enabled = _arg;
    return *this;
  }
  Type & set__aeb_active(
    const bool & _arg)
  {
    this->aeb_active = _arg;
    return *this;
  }
  Type & set__aeb_precharge(
    const bool & _arg)
  {
    this->aeb_precharge = _arg;
    return *this;
  }
  Type & set__aeb_enabled(
    const bool & _arg)
  {
    this->aeb_enabled = _arg;
    return *this;
  }
  Type & set__acc_braking(
    const bool & _arg)
  {
    this->acc_braking = _arg;
    return *this;
  }
  Type & set__acc_enabled(
    const bool & _arg)
  {
    this->acc_enabled = _arg;
    return *this;
  }
  Type & set__blis_l_alert(
    const bool & _arg)
  {
    this->blis_l_alert = _arg;
    return *this;
  }
  Type & set__blis_l_enabled(
    const bool & _arg)
  {
    this->blis_l_enabled = _arg;
    return *this;
  }
  Type & set__blis_r_alert(
    const bool & _arg)
  {
    this->blis_r_alert = _arg;
    return *this;
  }
  Type & set__blis_r_enabled(
    const bool & _arg)
  {
    this->blis_r_enabled = _arg;
    return *this;
  }
  Type & set__cta_l_alert(
    const bool & _arg)
  {
    this->cta_l_alert = _arg;
    return *this;
  }
  Type & set__cta_l_enabled(
    const bool & _arg)
  {
    this->cta_l_enabled = _arg;
    return *this;
  }
  Type & set__cta_r_alert(
    const bool & _arg)
  {
    this->cta_r_alert = _arg;
    return *this;
  }
  Type & set__cta_r_enabled(
    const bool & _arg)
  {
    this->cta_r_enabled = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__DriverAssist
    std::shared_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__DriverAssist
    std::shared_ptr<ds_dbw_msgs::msg::DriverAssist_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DriverAssist_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->decel != other.decel) {
      return false;
    }
    if (this->decel_src != other.decel_src) {
      return false;
    }
    if (this->fcw_active != other.fcw_active) {
      return false;
    }
    if (this->fcw_enabled != other.fcw_enabled) {
      return false;
    }
    if (this->aeb_active != other.aeb_active) {
      return false;
    }
    if (this->aeb_precharge != other.aeb_precharge) {
      return false;
    }
    if (this->aeb_enabled != other.aeb_enabled) {
      return false;
    }
    if (this->acc_braking != other.acc_braking) {
      return false;
    }
    if (this->acc_enabled != other.acc_enabled) {
      return false;
    }
    if (this->blis_l_alert != other.blis_l_alert) {
      return false;
    }
    if (this->blis_l_enabled != other.blis_l_enabled) {
      return false;
    }
    if (this->blis_r_alert != other.blis_r_alert) {
      return false;
    }
    if (this->blis_r_enabled != other.blis_r_enabled) {
      return false;
    }
    if (this->cta_l_alert != other.cta_l_alert) {
      return false;
    }
    if (this->cta_l_enabled != other.cta_l_enabled) {
      return false;
    }
    if (this->cta_r_alert != other.cta_r_alert) {
      return false;
    }
    if (this->cta_r_enabled != other.cta_r_enabled) {
      return false;
    }
    return true;
  }
  bool operator!=(const DriverAssist_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DriverAssist_

// alias to use template instance with default allocator
using DriverAssist =
  ds_dbw_msgs::msg::DriverAssist_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__STRUCT_HPP_
