// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ds_dbw_msgs:msg/DriverAssist.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__STRUCT_H_
#define DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'decel_src'
#include "ds_dbw_msgs/msg/detail/decel_src__struct.h"

/// Struct defined in msg/DriverAssist in the package ds_dbw_msgs.
typedef struct ds_dbw_msgs__msg__DriverAssist
{
  std_msgs__msg__Header header;
  /// Brake deceleration
  /// m/s^2
  float decel;
  ds_dbw_msgs__msg__DecelSrc decel_src;
  /// Forward Collision Warning
  bool fcw_active;
  bool fcw_enabled;
  /// Automated Emergency Braking
  bool aeb_active;
  bool aeb_precharge;
  bool aeb_enabled;
  /// Adaptive Cruise Control
  bool acc_braking;
  bool acc_enabled;
  /// Blind Spot Information System
  bool blis_l_alert;
  bool blis_l_enabled;
  bool blis_r_alert;
  bool blis_r_enabled;
  /// Cross Traffic Alert
  bool cta_l_alert;
  bool cta_l_enabled;
  bool cta_r_alert;
  bool cta_r_enabled;
} ds_dbw_msgs__msg__DriverAssist;

// Struct for a sequence of ds_dbw_msgs__msg__DriverAssist.
typedef struct ds_dbw_msgs__msg__DriverAssist__Sequence
{
  ds_dbw_msgs__msg__DriverAssist * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ds_dbw_msgs__msg__DriverAssist__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // DS_DBW_MSGS__MSG__DETAIL__DRIVER_ASSIST__STRUCT_H_
